#ifndef PETSCSOLVER_H
#define PETSCSOLVER_H

#include <petscksp.h>
#include <petscdm.h>
#include <petscdmda.h>

#include <iomanip>
#include <iostream>
#include <mpi.h>

PetscErrorCode ComputeMatrix(KSP,Mat,Mat,void*);

class PETScSolver
{
  int *bound;
  
  const double iepsilon0 = 1./8.854187817E-12;
  double ih;
  int rank, worldsize;

  int imin,imax,jmin,jmax,kmin,kmax;
  int Ni,Nj,Nk,Nall;

  KSP ksp;
  DM da;
  Vec x,b;
  
  PetscLogStage stage[2];
  double time_in_solve=0.,time_in_KSPSolve=0.;
  int total_number_of_KSP_iterations=0,i_solve=0;

public:
  int total_number_of_solve_iterations;
  
  PETScSolver(int,int,int,int*,int*,int*,int*,double);
  ~PETScSolver();

  int initialize_petsc(int g_Ni,int g_Nj,int g_Nk,int* dims,int* l_Ni,int* l_Nj,int* l_Nk);
  void initialize_matrix(int*);

  void initsolve(double*,double*);
  void solve(int,double*,double*);
};

#endif
